#include <bits/stdc++.h>

using namespace std;

int h, n;
int vodotok[1000005];
bool linija[1000005];

int startPos, endPos, protok;

int main()
{
    scanf("%d %d", &h, &n);
    for (int i = 0; i < h; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            if (i == 0)
            {
                vodotok[j] = 1;
            }
            scanf("%d", &linija[j]);
        }
        for (int j = 0; j < n; ++j)
        {
            if (linija[j] == 0)
            {
                if (j == 0)
                {
                    vodotok[j+1] += vodotok[j];
                    vodotok[j] = 0;
                    if (linija[j+1] == 0)
                    {
                        for (int l = 0; l < n; ++l)
                        {
                            if (linija[l] == 0)
                            {
                                vodotok[l+1] += vodotok[l];
                                vodotok[l] = 0;
                            }
                            else
                            {
                                j = l;
                                break;
                            }
                        }
                    }
                }
                else if (j == n-1)
                {
                    vodotok[j-1] += vodotok[j];
                    vodotok[j] = 0;
                }
                else
                {
                    if (linija[j+1] == 0)
                    {
                        startPos = j;
                        endPos = j;
                        protok = 0;
                        for (int l = j+1; l < n; ++l)
                        {
                            if (linija[l] == 0)
                            {
                                endPos = l;
                            }
                            else break;
                        }
                        if (endPos == n-1)
                        {
                            for (int l = startPos; l <= endPos; ++l)
                            {
                                vodotok[startPos-1] += vodotok[l];
                                vodotok[l] = 0;
                            }
                        }
                        else
                        {
                            for (int l = startPos; l <= endPos; ++l)
                            {
                                protok += vodotok[l];
                                vodotok[l] = 0;
                            }
                            if (protok % 2 == 0)
                            {
                                vodotok[startPos-1] += protok/2;
                                vodotok[endPos+1] += protok/2;
                            }
                            else
                            {
                                if (i % 2 == 0)
                                {
                                    vodotok[startPos-1] += protok/2+1;
                                    vodotok[endPos+1] += protok/2;
                                }
                                else
                                {
                                    vodotok[startPos-1] += protok/2;
                                    vodotok[endPos+1] += protok/2+1;
                                }
                            }
                        }
                        if (endPos < n-1)
                        {
                            j = endPos;
                        }
                        else break;
                    }
                    else
                    {
                        if (vodotok[j] % 2 == 0)
                        {
                            vodotok[j-1] += vodotok[j]/2;
                            vodotok[j+1] += vodotok[j]/2;
                        }
                        else
                        {
                            if (i % 2 == 0)
                            {
                                vodotok[j-1] += vodotok[j]/2 + 1;
                                vodotok[j+1] += vodotok[j]/2;
                            }
                            else
                            {
                                vodotok[j-1] += vodotok[j]/2;
                                vodotok[j+1] += vodotok[j]/2 + 1;
                            }
                        }
                    }
                    vodotok[j] = 0;
                }
            }
        }
    }
    for (int i = 0; i < n; ++i)
    {
        printf("%d ", vodotok[i]);
    }
    return 0;
}